'To estimate centroids from lon/lat data.
'Assumes a file in the Flow Mapper polygon format.
'20050601

DECLARE SUB Cent (Nr%, LatBar, Longitude(), Latitude())
CLOSE
CLS

OPTION BASE 1
Pi = 3.14159265
Rad = Pi / 180
MaxN% = 0

COLOR 14
PRINT "The program estimates centroids for polgons"
PRINT "defined by longitude/latitude coordinates."
PRINT "Input values are assumed to be in decimal degrees."
COLOR 7
PRINT
PRINT "Enter a value larger than the number of nodes"
INPUT "in the largest polygon"; Size%

INPUT "Now enter a value larger than the number of regions "; Regions%

DIM SHARED Latitude(Size%), Longitude(Size%)
DIM MaxX(Regions%), MaxY(Regions%), MinX(Regions%), MinY(Regions%)

INPUT "Enter the input polygon file name "; InFile$
'InFile$ = "C;\docume~1\waldo\mydocu~1\shapes~1\Albania\New_map.txt"
'InFile$ = "C:\new_map.txt"
OPEN "I", #1, InFile$

INPUT "Enter the name of a file for centroid output "; OutFile$
'OutFile$ = "C:\docume~1\waldo\mydocu~1\shapes~1\albania\Centers1.txt"
OPEN "O", #2, OutFile$

INPUT "Enter a file name for the 'average' output "; OutFile1$
'OutFile1$ = "C:\MnCntr1.txt"
OPEN "O", #3, OutFile1$

PRINT #3, "The average longitude & Latitudes follow.:"
PRINT #3, "The average is NOT the center of gravity!"
PRINT #3, "But it is likely to be close."
PRINT #3,

DO WHILE NOT EOF(1)
  SumN% = 0
  SumLat = 0!
  SumLon = 0!
  Regs% = Regs% + 1
 'PRINT "Regs ="; Regs%
 
  INPUT #1, Npts%
 'PRINT "Npts ="; Npts%
 
  IF Npts% = 0 THEN GOTO GotAll
  IF Npts% > MaxN% THEN
    MaxN% = Npts%
    MaxPoly = Regs%
  END IF

  MaxLat = -400
  MaxLon = -400
  MinLat = -MaxLat
  MinLon = -MaxLon

  FOR I% = 1 TO Npts%

    INPUT #1, Lon, Lat
     'Read all the points in the polygon
      SumN% = SumN% + 1

      Latitude(I%) = Lat
      Longitude(I%) = Lon
     
      IF Lat < MinLat THEN MinLat = Lat
      IF Lat > MaxLat THEN MaxLat = Lat
      IF Lon < MinLon THEN MinLon = Lon
      IF Lon > MaxLon THEN MaxLon = Lon
      SumLon = SumLon + Lon
      SumLat = SumLat + Lat
     
      IF I% = Npts% THEN
       'Adjust for closed polygons
        SumLon = SumLon - Lon
        SumLat = SumLat - Lat
        SumN% = SumN% - 1
      END IF
  NEXT I%
  MaxX(Regs%) = MaxLon
  MinX(Regs%) = MinLon
  MaxY(Regs%) = MaxLat
  MinY(Regs%) = MinLat

 'Now convert and estimate centroid for this polygon
  LatBar = SumLat / SumN%
  LonBar = SumLon / SumN%
  PRINT #3, Regs%; LonBar; LatBar
 'PRINT #3, "Mean latitude of region"; Regs%
 'PRINT #3, "with"; Npts%; "pts is"; LatBar
 'PRINT #3, "Mean Longitude of the region is "; LonBar
  LatBar = LatBar * Rad    'Converting to radians
  FOR K% = 1 TO SumN%
   'Adjust for the convergence of the meridians
    Longitude(K%) = COS(LatBar) * Longitude(K%)
  NEXT K%
  PRINT #2, Regs%;
 
  CALL Cent(SumN%, LatBar, Longitude(), Latitude())

LOOP

CLOSE 1

GotAll:
Regs% = Regs% - 1

PRINT #3,
PRINT #3, "The following are the bounds for the indiviual polygons"
PRINT #3,
PRINT #3, "               Longitude (max, min)        Latitude (max, min)"
FOR I% = 1 TO Regs%
  PRINT #3, I%, MaxX(I%); MinX(I%), MaxY(I%); MinY(I%)
NEXT I%
PRINT #2,
PRINT #2, "These are the estimated region centroids"
PRINT #2,
PRINT #2, "This is file "; OutFile$
PRINT #2, "The data came from file "; InFile$
PRINT #2,
PRINT #3,
PRINT #3, "This is file "; OutFile1$
PRINT #3, "The data came from file "; InFile$
PRINT #3,
PRINT #2, "There were;"; Regs%; "Regions."
PRINT #2, "The largest region ("; MaxPoly; ") was a polygon of"; MaxN%; "points."
PRINT #2,
PRINT #2, "Finished at "; TIME$; " on "; DATE$
PRINT #2,
PRINT #3, "There were;"; Regs%; "Regions."
PRINT #3, "The largest region ("; MaxPoly; ") was a polygon of"; MaxN%; "points. "
PRINT #3,
PRINT #3, "Finished at "; TIME$; " on "; DATE$
PRINT
PRINT "Your results are in file: "
COLOR 14
PRINT OutFile$
COLOR 7
PRINT "and in:'"
COLOR 14
PRINT OutFile1$
PRINT
COLOR 7
PRINT #2, "Thank Waldo Tobler for this computer program."
PRINT #3,
PRINT #3, "Thank Waldo Tobler for this computer program."
PRINT #2,
CLOSE
END

SUB Cent (Nr%, LatBar, Px(), Py())
'Compute the center of gravity from spherical coordinates.
'When working with lat/Lon data
'X=Longitude, Y= Latitude
Pi = 3.1415
Rad = Pi / 180!
Cbar = 1 / COS(LatBar)
B1 = 0
B2 = 0
FOR K% = 1 TO Nr%
 'PRINT "K="; K%; "Nr="; Nr%
  M% = K% + 1
  IF M% > Nr% THEN M% = 1
  B1 = (Py(M%) - Py(K%)) * (Px(K%) ^ 2 + Px(K%) * Px(M%) + Px(M%) ^ 2) + B1
  B2 = Px(K%) * Py(M%) - Px(M%) * Py(K%) + B2
NEXT K%
IF B2 <> 0 THEN
  CenX = B1 / (3! * B2)
END IF
B1 = 0
B2 = 0
PRINT #2, CenX * Cbar;
FOR K% = 1 TO Nr%
  M% = K% + 1
  IF M% > Nr% THEN M% = 1
  B1 = (Px(M%) - Px(K%)) * (Py(K%) ^ 2 + Py(K%) * Py(M%) + Py(M%) ^ 2) + B1
  B2 = Py(K%) * Px(M%) - Py(M%) * Px(K%) + B2
NEXT K%
IF B2 <> 0 THEN
  CenY = B1 / (3! * B2)
END IF
PRINT #2, CenY
EXIT SUB
END SUB

