C     VOLUME PRESERVING INTERPOLATION                                          
C     FOR USE WITH AGGREGATE CENSUS DATA                                       
C     W.R.TOBLER ANN ARBOR DECEMBER 1976                                       
C     NR=NO. OF REGIONS
C     IN=1 TO RESTART, 0 OTHERWISE                          
C     ROWS,COLS DEFINE THE SIZE OF THE ARRAY                                   
C     ITER=NUMBER OF ITERATIONS REQUESTED                                      
C     NEU=0 RESULTS IN DIRICHLET CONDITION, EDGE=ZERO                          
C     NEU=1 FOR DZ/DN=0
C     LAP=1 YIELDS LAPLACIAN DEFINITION OF SMOOTHNESS                          
C     LAP=0 YIELDS BIHARMONIC DEFINITION OF SMOOTHNESS                         
C     NEU=0 LAP=1 TRAP=0 IS SIMPLEST                                           
C     TRAP=1 AND NEU=2 STILL GIVE CURIOUS, DIVERGENT (?), RESULTS              
C     VERSION 003 OF THE PROGRAM, 22 JAN 1977.                                 
      DIMENSION DZ(65,99)                                                      
      DIMENSION FMT(18),TITL(18),A(99),H(99),DS(99),D(99),ZD(99),AA(99)        
      COMMON Z(65,99),ID(65,99)                                                
      INTEGER ROWS,COLS,CM1,RM1                                                
      INTEGER CM3,RM3,CM4,RM4,TRAP                                             
      NC=20                                                                    
      READ(5,1) NR,ROWS,COLS,ITERS,IN,NEU,LAP,TRAP                             
 1    FORMAT(3I2,I3,4I1)                                                       
      NR1=NR+1                                                                 
      RC=ROWS*COLS                                                             
      HS=0.0                                                                   
      HSUM=0.0                                                                 
      READ(5,2) FMT                                                            
 2    FORMAT(18A4)                                                             
      READ(5,2) TITL                                                           
      DO 3 K=1,NR                                                              
      H(K)=0.                                                                  
      A(K)=0.0                                                                 
      IF(IN.GT.0) GO TO 3                                                      
      READ(4,FMT) H(K)                                                         
      HSUM=HSUM+H(K)                                                           
 3    CONTINUE                                                                 
      IF(IN.GT.0) GO TO 75                                                     
      GO TO 77                                                                 
 75   CONTINUE                                                                 
      DO 76 I=1,ROWS                                                           
      READ(4,FMT) (Z(I,J),J=1,COLS)                                            
 76   CONTINUE                                                                 
 77   CONTINUE                                                                 
      DO 5 I=1,ROWS                                                            
      READ(4,109) (ID(I,J),J=1,COLS)                                           
 109  FORMAT((40I2))                                                           
      DO 4 K=1,COLS                                                            
      M=ID(I,K)                                                                
      IF(IN.GT.0) H(M)=H(M)+Z(I,K)                                             
      IF(IN.GT.0) HSUM=HSUM+H(M)                                               
 4    A(M)=A(M)+1.0                                                            
 5    CONTINUE                                                                 
      WRITE(6,110) TITL                                                        
      DO 50 M=1,NR                                                             
      DS(M)=0.0                                                                
      IF(A(M).EQ.0.0) WRITE(6,11) M,H(M),A(M)                                  
 11   FORMAT(I4,1X,E15.6,1X,F6.0,' ZERO AREA')                                 
      IF (A(M).EQ.0.0) AA(M)=0.0                                               
      IF(A(M).NE.0.) AA(M)=1./A(M)                                             
       D(M)=H(M)*AA(M)                                                         
      IF(A(M).NE.0.0) WRITE(6,12) M,H(M),A(M),D(M)                             
 50   CONTINUE                                                                 
      D(NR1)=0.0                                                               
      H(NR1)=0.0                                                               
      DS(NR1)=0.0                                                              
      ZD(NR1)=0.0                                                              
 12   FORMAT(I4,1X,E15.6,1X,F6.0,1X,E15.6)                                     
      WRITE(6,12) NR1,H(NR1),A(NR1),D(NR1)                                     
      WRITE(6,12) NR1,HSUM                                                     
C     SET INITIAL DENSITIES, UNLESS READ IN                                    
      IF(IN.GT.0) GO TO 61                                                     
      DO 60 J=1,COLS                                                           
      DO 60 I=1,ROWS                                                           
      IR=ID(I,J)                                                               
      Z(I,J)=D(IR)                                                             
 60   CONTINUE                                                                 
 61   CONTINUE                                                                 
      CALL GREY2(ROWS,COLS,NC,TITL)                                            
      IF(ITER.EQ.0) GO TO 600                                                  
      CM1=COLS-1                                                               
      RM1=ROWS-1                                                               
      CM3=COLS-3                                                               
      RM3=ROWS-3                                                               
      CM4=CM3-1                                                                
      RM4=RM3-1                                                                
C     START ITERATIONS                                                         
      T3=2500.                                                                 
      T2=0.0                                                                   
      DO 500 K=1,ITERS                                                         
      IF(K.GT.1) T2=S2                                                         
      S2=0.0                                                                   
C     FIRST PASS                                                               
      IF(NEU.GT.0) CALL EDGE(ROWS,COLS,NR,NEU)                                 
      DO 101 J=2,CM1                                                           
      JM1=J-1                                                                  
      JP1=J+1                                                                  
      DO 100 I=2,RM1                                                           
      IR=ID(I,J)                                                               
      IF(IR.GT.NR) GO TO 80                                                    
C     LOOK AT DEPARTURE FROM SMOOTHNESS                                        
      IF(LAP.GT.0) GO TO 90                                                    
      IF((J.LT.3).OR.(J.GT.CM3)) GO TO 90                                      
      IF((I.LT.3).OR.(I.GT.RM3)) GO TO 90                                      
      IM1=I-1                                                                  
      IP1=I+1                                                                  
C     BIHARMONIC DEFINITION OF SMOOTHNESS                                      
      AVE=0.05*((Z(IM1,J)+Z(I,JM1)+Z(IP1,J)+Z(I,JP1))*8.0                      
     +-(Z(IM1,JM1)+Z(IM1,JP1)+Z(IP1,JP1)+Z(IP1,JM1))*2.0                       
     +-(Z(I-2,J)+Z(I,J-2)+Z(I,J+2)+Z(I+2,J)))                                  
      GO TO 98                                                                 
 90   CONTINUE                                                                 
C     LAPLACIAN DEFINITION OF SMOOTHNESS                                       
      AVE=0.25*(Z(I-1,J)+Z(I+1,J)+Z(I,J-1)+Z(I,J+1))                           
 98   CONTINUE                                                                 
      DZZ=AVE-Z(I,J)                                                           
      S2=S2+DZZ**2                                                             
      DZZ=DZZ*0.25                                                             
      DS(IR)=DS(IR)+DZZ                                                        
      DZ(I,J)=DZZ                                                              
      GO TO 100                                                                
 80   CONTINUE                                                                 
C     TREATS PARTS OUTSIDE DOMAIN, "THE BOUNDARY"                              
C     DIRICHLET CONDITION, EDGE=ZERO                                           
      IF(NEU.EQ.0) GO TO 100                                                   
C     OR NEUMANN CONDITION ON BOUNDARY                                         
      IF(NEU.EQ.1) GO TO 81                                                    
      IF((J.LT.4).OR.(J.GT.CM4)) GO TO 81                                      
      IF((I.LT.4).OR.(I.GT.RM4)) GO TO 81                                      
      AVE=(-2.*(Z(I,J+3)+Z(I,J-3)+Z(I+3,J)+Z(I-3,J))                           
     ++3.*(Z(I,J+2)+Z(I,J-2)+Z(I+2,J)+Z(I-2,J)))*0.25                          
      GO TO 89                                                                 
 81   CONTINUE                                                                 
      IF((J.LT.3).OR.(J.GT.CM3)) GO TO 82                                      
      IF((I.LT.3).OR.(I.GT.RM3)) GO TO 82                                      
      IF(NEU.EQ.2) AVE=-((Z(I,J+2)+Z(I+2,J)+Z(I-2,J)+Z(I,J-2))                 
     ++2.*(Z(I,J-1)+Z(I,J+1)+Z(I-1,J)+Z(I+1,J)))*0.25                          
      IF(NEU.EQ.1) AVE=0.25*(Z(I+2,J)+Z(I-2,J)+Z(I,J+2)+Z(I,J-2))              
      GO TO 89                                                                 
 82   CONTINUE                                                                 
       AVE=.25*(Z(I-1,J)+Z(I+1,J)+Z(I,J+1)+Z(I,J-1))                           
 89   CONTINUE                                                                 
      IF(AVE.LT.0.0) AVE=0.0                                                   
      Z(I,J)=AVE                                                               
 100  CONTINUE                                                                 
 101  CONTINUE                                                                 
      DO 105 IR=1,NR                                                           
C     DECREMENT BY AVERAGE INCREMENT                                           
      DS(IR)=-DS(IR)*AA(IR)                                                    
      ZD(IR)=0.0                                                               
 105  CONTINUE                                                                 
C     SECOND PASS                                                              
      DO 151 J=2,CM1                                                           
      DO 150 I=2,RM1                                                           
      IR=ID(I,J)                                                               
      IF(IR.GT.NR) GO TO 150                                                   
C     APPLY NORMALIZED ADJUSTMENT                                              
      ZT=Z(I,J)+DZ(I,J)+DS(IR)                                                 
      IF(ZT.LT.0.0)  ZT=0.0                                                    
      ZD(IR)=ZD(IR)+ZT                                                         
      Z(I,J)=ZT                                                                
 150  CONTINUE                                                                 
 151  CONTINUE                                                                 
      DO 205 IR=1,NR                                                           
      DS(IR)=0.0                                                               
      ZD(IR)=H(IR)-ZD(IR)                                                      
      IF(ZD(IR).GT.0.0) ZD(IR)=ZD(IR)*AA(IR)                                   
      D(IR)=0.0                                                                
 205  CONTINUE                                                                 
C     THIRD PASS, FOR RENORMALIZATION                                          
C     WHICH ENFORCES PYCNOPHYLACTIC CONDITION                                  
      DO 302 J=2,CM1                                                           
      DO 301 I=2,RM1                                                           
      IR=ID(I,J)                                                               
      IF(IR.GT.NR) GO TO 301                                                   
      IF(ZD(IR).GT.0.0) Z(I,J)=Z(I,J)+ZD(IR)                                   
      IF(ZD(IR).GE.0.0) GO TO 300                                              
      DZZ=-Z(I,J)                                                              
      IF(ZD(IR).GT. DZZ) GO TO 284                                             
      Z(I,J)=0.0                                                               
      ZD(IR)=ZD(IR)-DZZ                                                        
      GO TO 300                                                                
 284  Z(I,J)=Z(I,J)+ZD(IR)                                                     
      ZD(IR)=0.0                                                               
 300  CONTINUE                                                                 
      IF(TRAP.EQ.0) D(IR)=D(IR)+Z(I,J)                                         
      IF(TRAP.EQ.0) GO TO 299                                                  
      IM1=I-1                                                                  
      IP1=I+1                                                                  
      JM1=J-1                                                                  
      JP1=J+1                                                                  
      D(IR)=D(IR)+(0.25*(Z(IM1,JM1)+Z(IM1,JP1)+Z(IP1,JM1)                      
     ++Z(IP1,JP1))+0.5*(Z(IM1,J)+Z(IP1,J)+Z(I,JM1)+Z(I,JP1))                   
     ++Z(I,J))*0.25                                                            
 299  CONTINUE                                                                 
      DS(IR)=D(IR)-H(IR)                                                       
 301  CONTINUE                                                                 
 302  CONTINUE                                                                 
      S2=S2/RC                                                                 
C     STOPPING RULES                                                           
      WRITE(6,30) K,S2                                                         
      IF(K.EQ.1) TEST=S2                                                       
      IF(TEST.NE.0.0) T1=S2/TEST                                               
      IF(T1.LT.0.001) GO TO 600                                                
      IF(T2.NE.0.0) T3=S2/T2                                                   
      IF(T3.LT.0.01) GO TO 600                                                 
 30   FORMAT(3X,I5,2X,E15.6)                                                   
 500  CONTINUE                                                                 
 600  CONTINUE                                                                 
      CALL GREY2(ROWS,COLS,NC,TITL)                                            
      WRITE(7,111) ROWS,COLS                                                   
      WRITE(7,113)                                                             
 111  FORMAT(2I3)                                                              
 113  FORMAT(' ((5E15.6))')                                                    
      WRITE(6,110) TITL                                                        
 110  FORMAT('1',18A4)                                                         
      WRITE(6,111) ROWS, COLS                                                  
      WRITE(6,111) ITERS, IN                                                   
      WRITE(6,111) NR                                                          
      DO 700 I=1,ROWS                                                          
      WRITE(7,112) (Z(I,J),J=1,COLS)                                           
 112  FORMAT((5E15.6))                                                         
 700  CONTINUE                                                                 
      WRITE(6,110) TITL                                                        
      DO 750 K=1,NR                                                            
      HS=HS+D(K)                                                               
      WRITE(6,30) K, D(K)                                                      
 750  CONTINUE                                                                 
      WRITE(6,30) NR1,HS                                                       
      STOP                                                                     
      END                                                                      
      SUBROUTINE GREY2(IR,IC,NC,TITL)                                          
      DIMENSION TITL(18),Z(65,99)                                              
      COMMON X(65,99)                                                          
      CON=1./0.6                                                               
      IR1=IR*0.6                                                               
      WRITE(6,21)                                                              
      XMIN=X(1,1)                                                              
      XMAX=X(1,1)                                                              
 21   FORMAT(1H1,18A4)                                                         
      DO 31 J=1,IC                                                             
      DO 27 K=1,IR1                                                            
      XK=FLOAT(K)*CON                                                          
      KX=XK                                                                    
      Z(K,J)=X(KX,J)                                                           
      IF(Z(K,J).GT.XMAX) XMAX=Z(K,J)                                           
      IF(Z(K,J).LT.XMIN) XMIN=Z(K,J)                                           
 27   CONTINUE                                                                 
 31   CONTINUE                                                                 
      CALL GREY(IR1,IC,NC,TITL,XMAX,XMIN,Z)                                    
      WRITE(6,21)(TITL(I),I=1,18)                                              
      WRITE(6,22) XMAX,XMIN                                                    
 22   FORMAT(2X,2(E15.6,2X))                                                   
      RETURN                                                                   
      END                                                                      
      SUBROUTINE GREY(ILINE,LW,NC,TITLE,XMAX,XMIN,X)                           
C** ILINE - INTEGER NUMBER OF ROWS                                             
C** LW - INTEGER NUMBER OF PRINTING POSITIONS IN EACH ROW                      
C** NCL = NUMBER OF CLASSES                                                    
C** TITLE - SINGLE SUBSCRIPTED ARRAY CONTAINING TITLE OF MAP                   
C** XMAX - MAXIMUM VALUE OF X                                                  
C** XMIN - MINIMUM VALUE OF X                                                  
C** X - DOUBLE SUBSCRIPTED ARRAY CONTAINING VALUES TO BE                       
C**     MAPPED                                                                 
C** IN THE FOLLOWING STATEMENT 'X' MUST BE DIMENSIONED THE                     
C** SAME AS IN THE CALLING ROUTINE.                                            
      DIMENSION IAB(129),IA(129),IQ(129),QX(125),U(25),QC(21,8),               
     +TITLE(18),X(65,99)                                                       
      INTEGER QC,QX                                                            
      DATA IB,IM,IE,IP,IBB,II,IZ,IXX/'    ','----','====','++++','))))',       
     &'1111','ZZZZ','XXXX'/                                                    
      DATA IAA,IMM,I0,IPP,IDD,IH,IBBB,IC,IV/'AAAA','MMMM','0000','''''',       
     &'....','HHHH','BBBB','CCCC','VVVV'/                                      
      DATA ISLASH/'||||'/,IA/129*'----'/,IAB/129*'    '/,NCL/0/                
      IF(NCL.NE.0) GO TO 1                                                     
C     LOAD PRINTING SYMBOLS                                                    
      DO 60 I=1,21                                                             
      DO 60 K=1,8                                                              
60    QC(I,K)=IB                                                               
      QC(2,1)=IM                                                               
      QC(3,1)=IE                                                               
      QC(4,1)=IP                                                               
      QC(5,1)=IBB                                                              
      QC(6,1)=II                                                               
      QC(7,1)=IZ                                                               
      QC(8,1)=IXX                                                              
      QC(9,1)=IAA                                                              
      QC(10,1)=IMM                                                             
      DO 61 I=11,21                                                            
61    QC(I,1)=I0                                                               
      QC(11,2)=IM                                                              
      QC(12,2)=IE                                                              
      DO 62 I=13,16                                                            
      QC(I,2)=IP                                                               
62    QC(I,3)=IPP                                                              
      QC(13,3)=IB                                                              
      DO 63 I=17,21                                                            
      QC(I,2)=IXX                                                              
      QC(I,3)=IPP                                                              
      QC(I,4)=IDD                                                              
      QC(I,5)=IH                                                               
63    QC(I,6)=IBBB                                                             
      QC(15,4)=IDD                                                             
      QC(16,4)=IDD                                                             
      QC(16,5)=IE                                                              
      QC(17,5)=IM                                                              
      QC(17,6)=IB                                                              
      QC(18,6)=IC                                                              
      QC(20,7)=IV                                                              
      QC(21,7)=IV                                                              
      QC(21,8)=IAA                                                             
1     CONTINUE                                                                 
      WRITE(6,100)(TITLE(I),I=1,18)                                            
100   FORMAT('+',18A4,//)                                                      
      LL=LW+4                                                                  
      NCL=NC                                                                   
      IF (NCL.EQ.0) NCL=5                                                      
      IF(NC.GT.20) NCL=20                                                      
      NLEVLS=21                                                                
      NSTEPS=NLEVLS/NCL                                                        
      U(1)=XMIN                                                                
      DX=(XMAX-XMIN)/FLOAT(NCL)                                                
      JK=NCL+1                                                                 
      DO 2 I=2,JK                                                              
2     U(I)=U(I-1)+DX                                                           
      U(JK)=U(JK)*.00001+U(JK)                                                 
      IA(1)=IP                                                                 
      IA(LL)=IP                                                                
      ICA=IB                                                                   
      WRITE(6,150) (IA(I),I=1,LL)                                              
150   FORMAT(' ',129A1)                                                        
      IA(1)=ISLASH                                                             
      WRITE(6,20) IA(1),(IAB(I),I=1,LW),ICA,IA(1)                              
      DO 10 L=1,ILINE                                                          
      DO 7 I=1,LW                                                              
      IQ(I)=IB                                                                 
      IQ2=0                                                                    
      IF(X(L,I).LT.XMIN) GO TO 4                                               
      IF(X(L,I).GT.XMAX) GO TO 4                                               
      K2=0                                                                     
      IF(NSTEPS.EQ.1) K2=1                                                     
      DO 5  J=2,JK                                                             
      K2=K2+NSTEPS                                                             
       IF(X(L,I).LT.U(J)) GO TO 6                                              
5     CONTINUE                                                                 
      QX(I)=21                                                                 
      GO TO 7                                                                  
4     QX(I)=1                                                                  
      GO TO 7                                                                  
6     QX(I)=K2                                                                 
7     CONTINUE                                                                 
      WRITE(6,20) IA(1),(QC(QX(I),1),I=1,LW),ICA,IA(1)                         
20    FORMAT('9',A1,1X,127A1)                                                  
      DO 19 K=2,8                                                              
      WRITE(6,22) (QC(QX(I),K),I=1,LW)                                         
22    FORMAT('+  ',125A1)                                                      
19    CONTINUE                                                                 
10    CONTINUE                                                                 
      WRITE(6,20) IA(1),(IAB(I),I=1,LW),ICA,IA(1)                              
      IA(1)=IP                                                                 
      WRITE(6,150)(IA(I),I=1,LL)                                               
      RETURN                                                                   
      END                                                                      
      SUBROUTINE EDGE(IR,JC,NR,N)                                              
      COMMON Z(65,99),ID(65,99)                                                
C     ASSIGNS VALUES AT EDGE                                                   
      LC=JC-1                                                                  
      DO 50 I=1,IR                                                             
      J=1                                                                      
      IF(ID(I,J).LE.NR) GO TO 48                                               
      IF(N.EQ.1) A=Z(I,J+2)                                                    
      IF(N.EQ.2) A=3.*Z(I,J+2)-2.*Z(I,J+3)                                     
      IF (A.LT.0.) A=0.                                                        
      Z(I,J)=A                                                                 
 48   J=JC                                                                     
      IF(ID(I,J).LE.NR) GO TO 50                                               
      IF(N.EQ.1) A=Z(I,J-2)                                                    
      IF(N.EQ.2) A=3.*Z(I,J-2)-2.*Z(I,J-3)                                     
      IF(A.LT.0.) A=0.                                                         
      Z(I,J)=A                                                                 
 50   CONTINUE                                                                 
      DO 60 J=2,LC                                                             
      I=1                                                                      
      IF(ID(I,J).LE.NR) GO TO 58                                               
      IF(N.EQ.1) A=Z(I+2,J)                                                    
      IF(N.EQ.2) A=3.*Z(I+2,J)-2.*Z(I+3,J)                                     
      IF(A.LT.0.) A=0.                                                         
      Z(I,J)=A                                                                 
 58   I=IR                                                                     
      IF(ID(I,J).LE.NR) GO TO 60                                               
      IF(N.EQ.1) A=Z(I-2,J)                                                    
      IF(N.EQ.2) A=3.*Z(I-2,J)-2.*Z(I-3,J)                                     
      IF(A.LT.0.) A=0.                                                         
      Z(I,J)=A                                                                 
 60   CONTINUE                                                                 
      IF(ID(1,1).LE.NR) GO TO 1                                                
      IF(N.EQ.1) A=Z(3,1)                                                      
      IF(N.EQ.2) A=3.*Z(3,1)-2.*Z(4,1)                                         
      IF(A.LT.0.) A=0.                                                         
      Z(1,1)=0.5*(Z(1,1)+A)                                                    
 1    CONTINUE                                                                 
      IF(ID(1,JC).LE.NR) GO TO 2                                               
      IF(N.EQ.1) A=Z(3,JC)                                                     
      IF(N.EQ.2) A=3.*Z(3,JC)-2.*Z(4,JC)                                       
      IF(A.LT.0.) A=0.                                                         
      Z(1,JC)=0.5*(Z(1,JC)+A)                                                  
 2    CONTINUE                                                                 
      IF(ID(IR,1).LE.NR) GO TO 3                                               
      IF(N.EQ.1) A=Z(IR-2,1)                                                   
      IF(N.EQ.2) A=3.*Z(IR-2,1)-2.*Z(IR-3,1)                                   
      IF(A.LT.0.) A=0.                                                         
      Z(IR,1)=0.5*(Z(IR,1)+A)                                                  
 3    CONTINUE                                                                 
      IF(ID(IR,JC).LE.NR) GO TO 4                                              
      IF(N.EQ.1) A=Z(IR-2,JC)                                                  
      IF(N.EQ.2) A=3.*Z(IR-2,JC)-2.*Z(IR-3,JC)                                 
      IF(A.LT.0.) A=0.                                                         
      Z(IR,JC)=0.5*(Z(IR,JC)+A)                                                
 4    CONTINUE                                                                 
      RETURN                                                                   
      END                                                                      
