'To construct a from-to table fron named location pairs and a value.
'Tobler, Waldo 3-8-05
'MS QuickBasic 4.5
CLS
CLOSE
COLOR 14
PRINT
PRINT "   This program produces node numbers from named pairs and values."
PRINT "   The input is name 1, then name 2, then the value, all on one line."
PRINT "   The first location name identifies the origin."
PRINT "   The second location name identifies the destination."
PRINT "   The value is the quantity of traffic moving from name 1 to name 2."
PRINT "   None of the names should include blank spaces!"
PRINT "   The program results in a from-node number and a to-node number"
PRINT "   with the quantity moving between them, all printed on one line"
PRINT "   and a node by node table with values entered."
PRINT "   Location to same location cases go to the diagonal."
PRINT

COLOR 15

'Get input stuff:
PRINT
PRINT "   If you do not know the number of locations, make a high guess."
PRINT
INPUT "   Enter the number of locations "; Nodes
PRINT
INPUT "   Enter the name of the file containing the data "; Infile$
'Infile$ = "C:\French.txt"
INPUT "   Next enter the name of the file for the results "; OutFile$
'OutFile$ = "C:\Nam2Node.txt"
INPUT "   Do you wish printer output as well as the from-to table N/Y"; Ink$
Ink$ = UCASE$(Ink$)
IF UCASE$(Ink$) <> "Y" THEN
  Ink = 0
  PRINT "   Printer output will not be provided."
ELSE
  Ink = 1
  PRINT
  PRINT "   Printer output will be provided if one is attached and turned on."
  END IF
IF Ink <> 0 THEN
  LPRINT "RESULTS OF THE CONVERSION OF PLACE NAMES TO NODES AND TO A FROM-TO TABLE."
  LPRINT "Run of the Nam2Node program on "; DATE$; " begun at "; TIME$
  LPRINT
  LPRINT "Echoing input values"
END IF

OPEN "O", #2, OutFile$
PRINT #2, "Results from the names to node program."

DIM N$(20 * Nodes + 2)
'Each entry is (1) assigned a node number, with its name,
'On the this pass just assign each name a unique node number,
'and check for duplicate names.
'On the next pass associate the value with the node pair.
'Ignore the value on this first pass

OPEN "I", #1, Infile$
K = 0
K2 = 0
DO WHILE NOT EOF(1)

'If this is the first pair give the first name the Node number 1
'and give the second name the Node number 2.
'For the rest of the list the names must be compared to the
'already assigned node numbers.

  INPUT #1, A$
  K2 = K2 + 1
  L = LEN(A$)
  IF Ink <> 0 THEN LPRINT K2; " "; A$
  IF K2 = 1 THEN
    FOR I = 1 TO L
     'Look at each sysmbol. Split the names at the blank space.
     'Get the first name from the first data line
      IF MID$(A$, I, 1) = " " THEN
        K = K + 1
        N$(K) = MID$(A$, 1, I - 1)
        'LPRINT "Name 1 is "; N$(K); " K is"; K
       'Now look for the second name from the first data line
        LetterCount = 0
        I1 = I + 1
        FOR Q = I1 TO L
          LetterCount = LetterCount + 1
          IF MID$(A$, Q, 1) = " " THEN
            LetterCount = LetterCount - 1
            Name2$ = MID$(A$, I1, LetterCount)
            'LPRINT "Name 2 is "; Name2$
            IF Name2$ <> N$(K) THEN
              K = K + 1
              N$(K) = Name2$
              'PRINT "Second;"; K; "name is "; N$(K); " K is"; K
              GOTO Itself
            ELSE
             'This is the same point
             'What to do?
              PRINT #2, "The first origin is sending stuff to itself."
              PRINT #2, "It will not be counted twice as a node."
              PRINT #2, "But check the value for this item on the table diagonal."
              Diag = Diag + 1
              GOTO Itself
            END IF
          END IF
        NEXT Q
      END IF
    NEXT I
  END IF
  IF K2 > 1 THEN
     'LPRINT "Looking at line "; K2; "of length "; L
     'LPRINT K2; " "; A$
    'Get the next name pair
     FOR J = 1 TO L
      'LPRINT J; " "; MID$(A$, J, 1);
      'Look at each sysmbol. Split the names at the blank space.
      'Get the first name from the next data line
       IF MID$(A$, J, 1) = " " THEN GOTO FoundBlank
     NEXT J
FoundBlank:      
     'LPRINT "Found blank at position "; J
     Name1$ = MID$(A$, 1, J - 1)
    'LPRINT "Next name is "; Name1$; " This should be"; K + 1
    'Now compare it to all previous names
     FOR Q = 1 TO K
       IF Name1$ = N$(Q) THEN GOTO GotName
     NEXT Q
     K = K + 1
     N$(K) = Name1$
     'LPRINT "Here it is, name"; K; N$(K)
GotName:
    'Now look at the second name on this line
     J1 = J + 1
     'LPRINT "J1 is next non-blank letter "; J1
     LetterCount = 0
     FOR Q = J1 TO L
       LetterCount = LetterCount + 1
       IF MID$(A$, Q, 1) = " " THEN
         LetterCount = LetterCount - 1
         'LPRINT "Next blank letter is at "; LetterCount
         GOTO NextBlank
       END IF
     NEXT Q
NextBlank:
       Name2$ = MID$(A$, J1, LetterCount)
       'PRINT "Here is the 2nd name on this line "; Name2$
       IF Name1$ = Name2$ THEN
        'This is the same point
         PRINT #2, "CAUTION:"
         PRINT #2, "The location in entry line"; K2; "is sending stuff to itself."
         IF Diag >= 1 THEN GOTO GotIt
         PRINT #2, "It will not be counted as a new node, but the value it"
         PRINT #2, "carries will be on the diagonal of the resulting array"
         PRINT #2, "and counts as a table entry. Row and column sums are affected."
         PRINT #2,
         Diag = Diag + 1
         GOTO GotIt
       ELSE
        'Now compare it to all the previous names
         FOR Qk = 1 TO K
           IF Name2$ = N$(Qk) THEN GOTO GotIt
         NEXT Qk
        'It was not found so it must be new
         K = K + 1
         'PRINT "Fifth K is "; K
         'LPRINT "Name #"; K; "is "; Name2$
         N$(K) = Name2$
       END IF
GotIt:
  END IF
Itself:

LOOP

PRINT
PRINT "   The total number of unique points is:"; K
PRINT "   and these came from"; K2; "lines that were read from"
PRINT "   the input file: "; Infile$
CLOSE 1
PRINT
INPUT "   Press enter to contine ", Z$
'There are"; K; "uniquely identified location namess"

PRINT "The nodes are:"
IF Ink <> 0 THEN
  LPRINT
  LPRINT "The"; K; "nodes and their names are:"
END IF
FOR I = 1 TO K
  PRINT I; N$(I)
  IF Ink <> 0 THEN LPRINT I; N$(I)
NEXT I
PRINT
PRINT K; "unique nodes were found."
PRINT

'Second pass to get the paired nodes and traffic value,
'and to put entries into the K by K table.
'Start the next procedure:
Fmt$ = "#####"
K2 = 0
IF Ink <> 0 THEN
  LPRINT
  LPRINT "The array entries are:"
  LPRINT "(Row, Columns, value)"
END IF

OPEN "I", #1, Infile$
DIM T(K, K)

DO WHILE NOT EOF(1)
  INPUT #1, A$
  L = LEN(A$)
  FOR I = 1 TO L
   'look at each sysmbol. Split the names at the blank space.
    IF MID$(A$, I, 1) = " " THEN
      Name1$ = MID$(A$, 1, I - 1)
     'PRINT "Name 1 is "; Name1$
     'Now look for the second name
      LetterCount = 0
      FOR Q = I + 1 TO L
        LetterCount = LetterCount + 1
        IF MID$(A$, Q, 1) = " " THEN
          LetterCount = LetterCount - 1
          Name2$ = MID$(A$, I + 1, LetterCount)
         'PRINT "Name 2 is "; Name2$
         'Now get the value
          V = VAL(MID$(A$, Q, L))
         'PRINT "The value is "; V
          GOTO GotEm2
        END IF
      NEXT Q
    END IF
  NEXT I
GotEm2:
  'compare the input name with the node names
  FOR Q = 1 TO K
    IF Name1$ = N$(Q) THEN
       R = Q
       GOTO GotRow
     END IF
   NEXT Q
GotRow:
     FOR M = 1 TO K
       IF Name2$ = N$(M) THEN
         C = M
         GOTO GotCol
       END IF
     NEXT M
GotCol:
  'Put the values into the array
   T(R, C) = V
   K2 = K2 + 1
  'Make a printed record
   IF Diag > 0 AND R = C THEN
     IF Ink <> 0 THEN LPRINT N$(R); "  "; N$(C); V; ".....Diagonal"
   ELSE
     IF Ink <> 0 THEN LPRINT N$(R); "  "; N$(C); V
   END IF

LOOP
                   
IF Ink <> 0 THEN
  LPRINT
  LPRINT "There are"; K2; "non-zero entries in the final array,"
  IF Diag > 1 THEN
    LPRINT "including"; Diag; "diagonal values."
  ELSE
    IF Diag > 0 THEN LPRINT "including a single diagonal value."
  END IF
END IF

PRINT #2,
PRINT #2, "Computation completed at "; TIME$; " on "; DATE$
PRINT #2, "This is file "; OutFile$
PRINT #2, "The array is"; K; "by"; K; "in size with"; K2
PRINT #2, "non-zero entries from"; K * K - K; "possibilities,"
IF Diag > 0 THEN
  IF Diag > 1 THEN
    PRINT #2, "with"; Diag; "diagonal values."
  ELSE
    IF Diag > 0 THEN PRINT #2, "with a single value on the diagonal."
  END IF
END IF
PRINT #2, "The data came from "; Infile$
PRINT #2, "Program Nam2Node provided by W. Tobler"
PRINT #2,
DIM RowSum(K + 1), ColSum(K + 1)
'Now write out the result
FOR R = 1 TO K
  FOR C = 1 TO K
    ColSum(C) = ColSum(C) + T(R, C)
    RowSum(R) = RowSum(R) + T(R, C)
    PRINT #2, USING Fmt$; T(R, C);
  NEXT C
  PRINT #2,
NEXT R
PRINT #2,
PRINT "The computation was completed at "; TIME$; " on "; DATE$
PRINT "The results were sent to "; OutFile$
IF Ink <> 0 THEN LPRINT
IF Ink = 0 THEN GOTO SkipPrnt
LPRINT "Row and column sums,"
LPRINT "To check for zero rows or columns in the final table."
IF Diag > 0 THEN LPRINT "Also check the diagonal for entries."
FOR I = 1 TO K
  LPRINT I; ": "; RowSum(I); ColSum(I)
NEXT I
LPRINT
LPRINT "The computation was completed at "; TIME$; " on "; DATE$
LPRINT "The data came from "; Infile$
LPRINT "The from-to table went to "; OutFile$
SkipPrnt:
CLOSE
INPUT "Press enter to continue ", Z$
END

