'To compute optimal threshold from a square array
'For use in conjunction with a flow mapping program.
'W. Tobler 9/78, revised 5/13/04
DECLARE SUB Sort (Npts!, X!())
CLOSE
CLS
OPTION BASE 1
Fmt1$ = "###.##"
LINE INPUT "Enter a title: "; T$
PRINT
INPUT "Enter the name of the file containing the array "; Infile$
''Infile$ = "C:\thrshld\migr9500.dat"
OPEN "I", #1, Infile$

INPUT "Enter the size of the square array "; N
N2 = N * N
Max = -1000000
Min = -Max

INPUT "Enter the name of a file for the results "; Outfile$
''Outfile$ = "C:\Thrshld\USAout"
OPEN "O", #2, Outfile$

INPUT "Enter file for graph data "; Gfile$
''Gfile$ = "C:\thrshld\GraphOut"
OPEN "O", #3, Gfile$

PRINT #2, "RESULT OF AN OPTIMAL THRESHOLD COMPUTATION"
PRINT #2,
PRINT #2, T$

DIM M(N, N), L(N2), MaxIJ(2), MinIJ(2)

'Read in the data
'Diagonal will be ignored!
FOR i = 1 TO N
  FOR j = 1 TO N
    INPUT #1, M(i, j)
    IF i = j THEN M(i, j) = 0
   'PRINT #2, M(I, J);     'For a test
  NEXT j
   'PRINT #2,
NEXT i

DoOver:
PA$ = "N"
INPUT "Do you want individual, gross, or net values (I/G/N)? ", Size$
Size$ = UCASE$(Size$)
IF Size$ <> "I" THEN
  INPUT "Print Array? (Y/N) ", PA$
  PA$ = UCASE$(PA$)
END IF
IF PA$ = "Y" THEN PRINT "Array will be printed"

IF Size$ = "I" THEN
'Look at all of the individual entries
  K = 0
 'ListLength is N2 - N
  FOR i = 1 TO N
    FOR j = 1 TO N
      IF i <> j THEN
     'Diagonal will be ignored!
	K = K + 1
	L(K) = M(i, j)
       'PRINT #2, "A test of 'Individual'"; K, L(K)   'A test
	TotVol = TotVol + L(K)
	IF L(K) > Max THEN
	  Max = L(K)
	  MaxIJ(1) = i: MaxIJ(2) = j
	END IF
	IF L(K) < Min THEN
	  Min = L(K)
	  MinIJ(1) = i: MinIJ(2) = j
	END IF
      END IF
    NEXT j
  NEXT i
  Ave = TotVol / K

ELSEIF Size$ = "G" THEN
 'Look at the sum of two entries
  IF PA$ = "Y" THEN
    PRINT #2,
    PRINT #2, "Gross values"
  END IF
  K = 0
 'ListLength is N2 - N
  FOR i = 1 TO N
    IF PA$ = "Y" THEN PRINT #2, "I="; i
    FOR j = 1 TO N
     'Diagonal will be ignored!
      IF i < j THEN
	K = K + 1
	L(K) = M(i, j) + M(j, i)
	IF PA$ = "Y" THEN PRINT #2, L(K);
       'PRINT #2, "A test of 'Gross' "; K; L(K)    'A Test
	TotVol = TotVol + L(K)
	IF L(K) > Max THEN
	  Max = L(K)
	  MaxIJ(1) = i: MaxIJ(2) = j
	END IF
	IF L(K) < Min THEN
	  Min = L(K)
	  MinIJ(1) = i: MinIJ(2) = j
	END IF
      END IF
    NEXT j
    IF PA$ = "Y" THEN PRINT #2,
  NEXT i
  IF PA$ = "Y" THEN PRINT #2,
  Ave = TotVol / K

ELSEIF Size$ = "N" THEN
 'Look at the difference of two entries
  IF PA$ = "Y" THEN
    PRINT #2,
    PRINT #2, "Net values"
  END IF
  K = 0
 'ListLength is (N2 - N) / 2
  FOR i = 2 TO N
    IF PA$ = "Y" THEN PRINT #2, "I="; i
    FOR j = 1 TO i
      IF i <> j THEN
       'Diagonal will be ignored!
	K = K + 1
	L(K) = ABS(M(i, j) - M(j, i))
	IF PA$ = "Y" THEN PRINT L(K);
       'PRINT #2, "A Test of 'Net' "; K; L(K)        'A Test
	TotVol = TotVol + L(K)
	IF L(K) > Max THEN
	  Max = L(K)
	  MaxIJ(1) = i: MaxIJ(2) = j
	END IF
	IF L(K) < Min THEN
	  Min = L(K)
	  MinIJ(1) = i: MinIJ(2) = j
	END IF
      END IF
    NEXT j
    IF PA$ = "Y" THEN PRINT #2,
  NEXT i
  IF PA$ = "Y" THEN PRINT #2,
  Ave = TotVol / K

ELSE
 'You made a mistake
  PRINT
  PRINT "That is not a valid response. Try again"
  GOTO DoOver
END IF

'Ok now we have a list of K entries.
Size = K
PRINT
PRINT "Choice of type of array was ";
IF Size$ = "I" THEN PRINT "Individual entries, all M(i,j)"
IF Size$ = "G" THEN PRINT "Gross entries, the sum M(i.j)+M(j,i)"
IF Size$ = "N" THEN PRINT "Net entries, the difference |M(i,j)-M(j,i)|"
PRINT "Number of table entries = "; Size
PRINT "Total Volume "; TotVol
PRINT "Largest value =  "; Max; "at"; MaxIJ(1); MaxIJ(2)
PRINT "Smallest value = "; Min; "at"; MinIJ(1); MinIJ(2)
PRINT "Average ="; Ave
PRINT
Bigest = Max

'Now sort the values
CALL Sort(K, L())

'FOR I = 1 TO K                'Testing sort
  'PRINT #2, I; L(I)
'NEXT I
'PRINT #2,

Wt = 1                          'Uniform weight

Smax = -1.9E+20                 'A very small number
Istar = 1
I1 = 1
number = 0!
sum = 0!
Counter = 1
'PRINT #2, "Printing I L(I) Number Sum Si"
'Now getting an estimate of the optimal cutoff
 PRINT #3, "I; L(I); Number; Sum; DifFerence"
FOR i = 1 TO K
  Count = 0
  Volume = 0
  I1 = Counter
  FOR j = I1 TO K
    Counter = j
    IF (L(j) > L(i)) THEN GOTO Enough
    Count = Count + 1
    Volume = Volume + L(j)
  NEXT j
Enough:
  number = number + Count / K
  sum = sum + Volume / TotVol
  Dif = number - sum * Wt
  PRINT #3, i; L(i); number; sum; Dif
  IF Dif <= Smax THEN GOTO Thirty
  TheSum = sum
  Smax = Dif
  Istar = i                             'I*
Thirty:
NEXT i

PRINT #2,
PRINT #2, "This is file "; Outfile$
PRINT #2, "The data came from "; Infile$
PRINT #2, "The array size is"; N; "by"; N
PRINT #2, "Choice of array type was: ";
IF Size$ = "I" THEN PRINT #2, "Individual entries, all M(i,j)"
IF Size$ = "G" THEN PRINT #2, "Gross; entries, the; sum; M(i.j) + M(j, i)"
IF Size$ = "N" THEN PRINT #2, "Net entries, the difference |M(i,j)-M(j,i)|"
PRINT #2,
PRINT #2, "Ignoring the diagonal:"
PRINT #2, "Number of table entries is"; Size
PRINT #2, "Total Volume ="; TotVol
PRINT #2, "Largest value =  "; Max; "at"; MaxIJ(1); MaxIJ(2)
PRINT #2, "Smallest value = "; Min; "at"; MinIJ(1); MinIJ(2)
PRINT #2, "Average = "; Ave
PRINT #2,
PRINT #2, "Now for an estimate of the optimal cutoff:"
PRINT #2, "Max score occurs at magnitude "; L(Istar)
PRINT #2, "At rank position of "; Istar; "of"; Size
PRINT #2, "Which removes";
PRINT #2, USING Fmt1$; Istar / K * 100;
PRINT #2, "% of flows lines,"
PRINT #2, "but only";
PRINT #2, USING Fmt1$; TheSum * 100;
PRINT #2, "% of volume,"
PRINT #2,

Cutoff = (L(Istar + 1) + L(Istar)) / 2
PctCutOff = Cutoff * 100 / L(K)
PRINT #2, "Remove all volumes below"; Cutoff; "(the optimum cutoff)"
'This is halfway between L(Istar) and the next larger value, namely  L(Istar+1)
SumK = 0
FOR i = 1 TO K
  IF L(i) < Cutoff THEN
    SumK = SumK + L(i)
   'Summing volume cut off
  END IF
NEXT i
PRINT #2, "Then"; K - Istar; "moves remain, with a total volume of"; TotVol - SumK
PRINT #2, "That is, remove the"; Istar; "smallest values, eliminating"; SumK; "of volume."
PRINT #2, "Optimum threshold is";
PRINT #2, USING Fmt1$; L(Istar + 1) / Bigest;
PRINT #2, "% of largest value,"
PRINT #2, "where largest value is = "; Bigest
PRINT #2, "Results for graphing in file "; Gfile$
PRINT #2,
PRINT #2, "These results are from a program to chose threshold size"
PRINT #2, "by Waldo Tobler. Version 2 of 5/13/2004"
PRINT #2, "Computed at "; TIME$; " on "; DATE$

PRINT
PRINT "The optimum cut-off is:"; Cutoff
PRINT "This removes";
PRINT USING Fmt1$; Istar / K * 100;
PRINT "% of flows lines,"
PRINT "but only";
PRINT USING Fmt1$; TheSum * 100;
PRINT "% of volume,"
PRINT "The number of remainling moves will be"; K - Istar
PRINT "More results are in file "; Outfile$
PRINT "Results for graphing in file "; Gfile$

CLOSE
END

SUB Sort (Npts, X())
FOR II = 1 TO Npts
  i = Npts - II + 1
  Im1 = i - 1
  FOR j = 1 TO Im1
    IF (X(j) > X(i)) THEN
      T = X(i)
      X(i) = X(j)
      X(j) = T
    END IF
  NEXT j
NEXT II
END SUB

